Unit ids8e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ids8e(var X :Array of Extended; var Y :Array of Extended;
                N :Integer; YP1 :Extended; YPN :Extended;
                var Y2 :Array of Extended; var U :Array of Extended);

implementation

procedure ids8e(var X :Array of Extended; var Y :Array of Extended;
                N :Integer; YP1 :Extended; YPN :Extended;
                var Y2 :Array of Extended; var U :Array of Extended);
var
N1,I,K,K1 :Integer;
SIG,P,QN,UN :Extended;
const
SYS071 :Extended = 1.34078079e155;
ZERO :Extended = 0.0e0;
label
_10,_20,_30,_40,_50,_60;
begin
if ( YP1 <= SYS071 ) 
 then goto _10;
Y2[0] := ZERO;
U[0] := ZERO;
goto _20;
_10:
Y2[0] := -0.5e0;
U[0] := (3.0e0/(X[1]-X[0]))*((Y[1]-Y[0])/(X[1]-X[0])-YP1);
_20:
N1 := N-1;
for I:=2 to N1 do
 begin
  SIG := (X[I-1]-X[I-2])/(X[I+0]-X[I-2]);
  P := SIG*Y2[I-2]+2.0e0;
  Y2[I-1] := (SIG-1.0e0)/P;
  U[I-1] := (6.0e0*((Y[I+0]-Y[I-1])/(X[I+0]-X[I-1])-(Y[I-1]-Y[I-2])
    /(X[I-1]-X[I-2]))/(X[I+0]-X[I-2])-SIG*U[I-2])/P;
_30:
 end;
if ( YPN <= SYS071 ) 
 then goto _40;
QN := ZERO;
UN := ZERO;
goto _50;
_40:
QN := 0.5e0;
UN := (3.0e0/(X[N-1]-X[N-2]))*(YPN-(Y[N-1]-Y[N-2])/(X[N-1]-X[N-2]));
_50:
Y2[N-1] := (UN-QN*U[N-2])/(QN*Y2[N-2]+1.0e0);
for K1:=1 to N1 do
 begin
  K := N1-K1+1;
  Y2[K-1] := Y2[K-1]*Y2[K+0]+U[K-1];
_60:
 end;
end;

end.
